/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1998, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name   :   DI_DEMO1.C                                         ;;
;;      Purpose     :   Demo program of PCI-7433 digital input             ;;
;;      Date        :   4/28/1998                                          ;;
;;      Revision    :   1.00                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
//#include "aclerr.h"
#include "std.h"
#include "video.h"
#include "key.h"
#include "acl_pci.H"

#define ACL_TitleColor      (WHITE | bgcolor(GREEN))
#define ACL_TextColor       (WHITE | bgcolor(BLUE))
#define ACL_BkColor         (BLUE | bgcolor(BLUE))
#define ACL_MsgColor        (RED|INVERSE)
#define ACL_ProgColor       (WHITE | bgcolor(BROWN))


U8  *acl_Title = "****** PCI-7433 DI DEMO (Single) ******";
U8  *acl_Copyright="Copyright (c) 1995-1998, ADLink Technology Inc.  All rights reserved.";

/*----------------------------------------------------------------------*/

void showMessage(std_UByte *msg)
{
    video_ClearBox(24, 0, 24, 79, INVERSE);
    video_CenterPutStr(24, msg, ACL_MsgColor);
}
/*----------------------------------------------------------------------*/

void main( void )
{
    I16     i, j, err, row, col, key;
    U32     hiData, loData;
    char    tmpBuf[80];
    U16     existCards, curCardNo;
    PCI_INFO        info;
        U32     bn;


    /*---------- PCI-7433 initial ------------------------------------------*/
    err = _7433_Initial(&existCards, &info);
    if(err != ERR_NoError) {
        printf("PCI BIOS does not exist\n");
        exit(1);
    }
    if(existCards == 0) {
        printf("PCI-7433 does not exist\n");
        exit(1);
    }

        /*----------------------------------------------------------------------*/
    video_Initial();
    video_CursorOff();
    video_Box(VIDEO_SINGLE, 0, 0,  4, 79, ACL_TitleColor);
    video_Box(VIDEO_DOUBLE, 5, 0, 23, 79, ACL_TextColor);
    video_ClearBox(24, 0, 24, 79, INVERSE | BLUE);
    video_CenterPutStr(1, acl_Title, ACL_TitleColor);
    video_CenterPutStr(3, acl_Copyright, ACL_TitleColor);
    showMessage(">>> Press <Esc> to quit <<<");
    row = 10;
    col = 20;
    video_PutStr(row-2,  col, "PCI-7433 input:", ACL_TextColor);

    curCardNo = PCI_CARD1;
    _7433_Software_Reset(curCardNo);

    _7433_DI_HiDW(curCardNo, &hiData);   // MSB DI for PCI-7433
        sprintf(tmpBuf,"The MSB Double Word of DI Data = %08lX", hiData);
    video_PutStr(row, col, tmpBuf, INVERSE);

    _7433_DI_LoDW(curCardNo, &loData);   // LSB DI for PCI-7433
    sprintf(tmpBuf,"The LSB Double Word of DI Data = %08lX", loData);
    video_PutStr(row+2, col, tmpBuf, INVERSE);

    key = !KEY_ESC;
    do {
         if(key_Hit())  key = key_Get();
         _7433_DI_HiDW(curCardNo, &hiData);      // MSB DI for PCI-7433
         sprintf(tmpBuf,"The MSB Double Word of DI Data = %08lX", hiData);
     video_PutStr(row, col, tmpBuf, INVERSE);

     _7433_DI_LoDW(curCardNo, &loData);  // LSB DI for PCI-7433
     sprintf(tmpBuf,"The LSB Double Word of DI Data = %08lX", loData);
     video_PutStr(row+2, col, tmpBuf, INVERSE);
    } while(key != KEY_ESC);
    video_CursorOn();
    video_ClearBox(24, 0, 24, 79, NORMAL);
}
